#!/usr/bin/env python
import inspect
import re
from getclass import getclass
import formatvalue
from objectname import objectname
from public import public


def isregex(obj):
    return isinstance(obj, re._pattern_type)


@public
def formatfunction(function, name=True, fullname=True,
                   formatvalue=formatvalue.formatvalue, firstarg=True):
    """todo"""
    _id = ""
    if name:
        _id = objectname(function, fullname=fullname)
    try:
        argspec = inspect.getargspec(function)
    except Exception:
        # TypeError: <built-in function chdir> is not a Python function
        # python2
        # python3 OK
        # but TypeError not catched :(
        return "%s()" % str(_id)
    if not formatvalue:
        def _formatvalue(value):
            return ""
        formatvalue = _formatvalue

    args = argspec.args

    if not firstarg:
        cls = getclass(function)
        if inspect.isclass(function) or cls:
            args = args[1:]
    result = inspect.formatargspec(
        args,
        *argspec[1:],
        formatvalue=formatvalue
    )
    # no space = .replace(", ",",")
    return str(_id + result)
